//
//  G15Device.h
//  G15
//
//  Created by Casey Fleser on 9/12/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <IOKit/usb/IOUSBLib.h>
#import <IOKit/hid/IOHIDLib.h>

#define kG15ReportBufferSize		9

typedef struct {
	UInt8		control[0x0020];
	UInt8		buffer[0x03c0];
} SLCDRec;


@interface G15Device : NSObject
{
	io_service_t				_serviceID;
	
	IOUSBDeviceInterface		**_usbDevice;
	IOHIDDeviceInterface122		**_hidDevice;
	IOHIDQueueInterface			**_hidQueue;
	UInt32						_locationID;
	UInt8						_buffer[kG15ReportBufferSize];
	
	BOOL						_clearKey;
	BOOL						_homeKey;
	BOOL						_scrollUpKey;
	BOOL						_scrollDownKey;
	BOOL						_endKey;
}

+ (UInt32)			locationID: (io_service_t) inServiceID;
+ (NSDictionary *)	deviceProperties: (io_service_t) inServiceID;

- (id)				initWithService: (io_service_t) inServiceID;
- (IOReturn)		initDeviceInterface;
- (IOReturn)		initHIDInterface;
- (IOReturn)		completeStartup;

- (void)			shutdownDevice;

- (void)			processReadData: (UInt32) inBufferSize;
- (void)			sendLCDData: (SLCDRec *) inData;

- (io_service_t)	serviceID;

@end
